#include <Servo.h> 
 
Servo stanga1;  //umar stanga - left shoulder
Servo stanga2;  //cot stanga - left arm 
Servo gripper;  // gripper
Servo dreapta1;  //umar dreapta - right shoulder
Servo dreapta2;  //cot dreapta - right arm
Servo deplasare;     
 
int pos1,pos2,pos3,pos4,pos5;
int miscare;     // valoare servo deplasare - movement servo
int sus = 14;    // ball detection pins
int mij = 15;    // ball detection pins
int jos = 16;    // ball detection pins
int ultrasonic = 17; //ultrasonic sensor pin
int valsus, valmij, valjos, valfront;
int senzorstanga = 8; // left side sensor
int senzordreapta = 9; // right side sensor
int pingreenled = 10;
int pinredled = 11;
int citirestanga, citiredreapta; // readings of left and right side sensors
int index, poz;
int win = 0;
int pozitie = 0;// variable which holds the robot position on the board - row that is currently scaned
int sens = 0; // hold the direction in which robot moves - sens=0(robot move left and scan board), sens=1(robot move right to place the ball), sens=3 or 4 return to the center of the board
int reverse = 0;
int board [3][3];
int rowdrop = 0;//ROW where "O" ball will be placed
int pozdrop = 0;//COLUMN where "O" ball will be placed
int mutare = 0;
int playerwin = 0;
int docwin = 0;
 
void setup() 
{ 
  stanga1.attach(2);
  stanga2.attach(3);
  gripper.attach(4);
  dreapta1.attach(5);
  dreapta2.attach(6);
  deplasare.attach(7);
  
  pinMode (sus, INPUT);
  pinMode (mij, INPUT);
  pinMode (jos, INPUT);
  pinMode (ultrasonic, INPUT);
  pinMode (senzorstanga, INPUT);
  pinMode (senzordreapta, INPUT);
  pinMode (pingreenled, OUTPUT);
  pinMode (pinredled, OUTPUT);
  
  Serial.begin(9600);
} 
 
void citire(int poz)//read the scanning sensors - arm sensors
     {
      valsus = analogRead(sus);
      valmij = analogRead(mij);
      valjos = analogRead(jos);   //citeste senzorii
      
      if (valsus < 340)
          {
           if (board[poz][0] == 0) board [poz][0] = 1; //write "1" when player ball is detected
          } 
      if (valmij < 300)
          {
           if (board[poz][1] == 0) board [poz][1] = 1;
          }
      if (valjos < 350)
          {
           if (board[poz][2] == 0) board [poz][2] = 1;
          }
      Serial.print("poz ");
      Serial.println(poz);
      Serial.print(board[poz][0]);
      Serial.print(board[poz][1]);
      Serial.println(board[poz][2]);
      Serial.print(valsus);
      Serial.print(" ");
      Serial.print(valmij);
      Serial.print(" ");
      Serial.println(valjos);
     }//end citire
     
void pickball()//pick a ball from balls holder
     {
      for (index = 1; index < 45; index ++)//brat inainte
       {
        pos1 = pos1 - 1;
        stanga1.write(pos1);
        delay(20);
       }
       
  for (index = 1; index < 34; index ++)//antebrat jos
       {
        pos2 = pos2 + 1;
        stanga2.write(pos2);
        delay(20);
       }
       
  for (index = 1; index < 35; index ++)//inchide gripper
       {
        pos3 = pos3 + 1;
        gripper.write(pos3);
        delay(20);
       }
       
  for (index = 1; index < 34; index ++)//antebrat sus
       {
        pos2 = pos2 - 1;
        stanga2.write(pos2);
        delay(20);
       }
     }//end pickball
     
void dropball()//drops the ball
     
     {
       for (index = 1; index < 35; index ++)//deschide gripper
       {
        pos3 = pos3 - 1;
        gripper.write(pos3);
        delay(20);
       }
     }//end dropball

void pozsus()//move left arm to column 1
     {
       mutare=0;
       Serial.println("pozsus");
       for (index = 1; index < 45; index ++)//brat inainte
       {
        pos1 = pos1 - 1;
        stanga1.write(pos1);
        delay(20);
       }
       
       for (index = 1; index < 75; index ++)//antebrat jos
       {
        pos2 = pos2 + 1;
        stanga2.write(pos2);
        delay(20);
       }
       
       delay (2000);
       dropball();
       
       for (index = 1; index < 75; index ++)//antebrat sus
       {
        pos2 = pos2 - 1;
        stanga2.write(pos2);
        delay(20);
       }
       
       for (index = 1; index < 90; index ++)//brat inapoi
       {
        pos1 = pos1 + 1;
        stanga1.write(pos1);
        delay(20);
       }
     }//end pozsus
     
void pozmij()//move left arm to column 2
     {
       mutare=0;
       Serial.println("pozmij");
       for (index = 1; index < 15; index ++)//brat inainte
       {
        pos1 = pos1 - 1;
        stanga1.write(pos1);
        delay(20);
       }
       
       for (index = 1; index < 50; index ++)//antebrat jos
       {
        pos2 = pos2 + 1;
        stanga2.write(pos2);
        delay(20);
       }
       
       delay (2000);
       dropball();
       
       for (index = 1; index < 50; index ++)//antebrat sus
       {
        pos2 = pos2 - 1;
        stanga2.write(pos2);
        delay(20);
       }
       
       for (index = 1; index < 60; index ++)//brat inapoi
       {
        pos1 = pos1 + 1;
        stanga1.write(pos1);
        delay(20);
       }
     }//end pozmij
     
void pozjos()////move left arm to column 3
     {
       Serial.println("pozjoz");
       mutare=0;
       for (index = 1; index < 25; index ++)//brat inapoi
       {
        pos1 = pos1 + 1;
        stanga1.write(pos1);
        delay(20);
       }
       
       for (index = 1; index < 20; index ++)//antebrat jos
       {
        pos2 = pos2 + 1;
        stanga2.write(pos2);
        delay(20);
       }
       
       delay (2000);
       dropball();
       
       for (index = 1; index < 20; index ++)//antebrat sus
       {
        pos2 = pos2 - 1;
        stanga2.write(pos2);
        delay(20);
       }
       
       for (index = 1; index < 20; index ++)//brat inapoi
       {
        pos1 = pos1 + 1;
        stanga1.write(pos1);
        delay(20);
       }
     }//end pozjos
     
void calculmutare()//compute the position where ball will be placed
     {
      int x = 0;
      int y = 0;
      int iesire = 0;
      mutare =1; //nu permite intrarea in rutina de calcul a mutarii inainte de lasarea bilei in poz. calculata
      Serial.println("calcul mutare");
      for (x = 0; x <=2; x++)
           {
            Serial.println();
            for (y = 0; y <=2; y++)
                {
                 Serial.print(board[x][y]);
                }
           }
      Serial.println();
      pickball();
      x = 0;
      y = 0;
      while((x<=2)&&(iesire ==0))//look for a free cell to place the ball and put "2" in the table
           {
             while((y<=2)&&(iesire ==0))
                  {
                   if (board [x][y] ==0)
                    {
                     rowdrop = x;
                     pozdrop = y;
                     board [x][y] = 2;
                     iesire = 1;
                     Serial.print("rowdrop ");
                     Serial.println(rowdrop);
                     Serial.print("pozdrop ");
                     Serial.println(pozdrop);
                    }
                   y = y + 1;
                  }
              y = 0;
              x = x + 1;
           }
     }//end calculmutare
     
void checkplayerwin()//check if player won
     {
      if ((board [0][0] == 1)&&(board [0][1] == 1)&&(board [0][2] == 1)) win = 1;
      if ((board [1][0] == 1)&&(board [1][1] == 1)&&(board [1][2] == 1)) win = 1;//check rows
      if ((board [2][0] == 1)&&(board [2][1] == 1)&&(board [2][2] == 1)) win = 1;
      
      if ((board [0][0] == 1)&&(board [1][0] == 1)&&(board [2][0] == 1)) win = 1;
      if ((board [0][1] == 1)&&(board [1][1] == 1)&&(board [2][1] == 1)) win = 1;//check columns
      if ((board [0][2] == 1)&&(board [1][2] == 1)&&(board [2][2] == 1)) win = 1;
      
      if ((board [0][0] == 1)&&(board [1][1] == 1)&&(board [2][2] == 1)) win = 1;//check diag.
      if ((board [2][0] == 1)&&(board [1][1] == 1)&&(board [0][2] == 1)) win = 1;
     }//end checkwin
     
void checkdocwin()//check if Doc won
     {
      if ((board [0][0] == 2)&&(board [0][1] == 2)&&(board [0][2] == 2)) win = 2;
      if ((board [1][0] == 2)&&(board [1][1] == 2)&&(board [1][2] == 2)) win = 2;//check rows
      if ((board [2][0] == 2)&&(board [2][1] == 2)&&(board [2][2] == 2)) win = 2;
      
      if ((board [0][0] == 2)&&(board [1][0] == 2)&&(board [2][0] == 2)) win = 2;
      if ((board [0][1] == 2)&&(board [1][1] == 2)&&(board [2][1] == 2)) win = 2;//check columns
      if ((board [0][2] == 2)&&(board [1][2] == 2)&&(board [2][2] == 2)) win = 2;
      
      if ((board [0][0] == 2)&&(board [1][1] == 2)&&(board [2][2] == 2)) win = 2;//check diag.
      if ((board [2][0] == 2)&&(board [1][1] == 2)&&(board [0][2] == 2)) win = 2;
     }//end checkdocwin
 
void loop() 
{ 
  int x,y;
  pos1 = 155; //centru 150 - set the default position for servos
  pos2 = 49; //centru 55
  pos3 = 70; //centru 90
  pos4 = 25; //centru 80
  pos5 = 145; //centru 90
  miscare = 88; //centru 88
  pozitie = 0;
  reverse = 0;
  sens = 0;
  //win = 0;
  for (x = 0; x <=2; x++)//initialize the board
           {
            for (y = 0; y <=2; y++)
                {
                 board [x][y] = 0;
                }
           }
  stanga1.write(pos1);//umar stanga
  stanga2.write(pos2);//cot stanga
  gripper.write(pos3);
  dreapta1.write(pos5);//umar dreapta
  dreapta2.write(pos4);//cot dreapta
  deplasare.write(miscare);
  
  if(win != 0)//wait for table clearing
     {
      for (x=0; x<10; x++)
      {
       digitalWrite(pingreenled, HIGH);
       delay(1000);
       digitalWrite(pingreenled, LOW);
       digitalWrite(pinredled, HIGH);
       delay(1000);
       digitalWrite(pinredled, LOW);
       delay(1000);
      }
      win =0;
     }
  delay (5000);
  while (win == 0)//no winning condition is met
     {
       citirestanga = digitalRead (senzorstanga); //read left side sensor
       citiredreapta = digitalRead (senzordreapta);// read right side sensor
       valfront = analogRead(ultrasonic);//read front ultrasonic sensor
       
       digitalWrite(pingreenled, HIGH);//green LED is turned on
       digitalWrite(pinredled, LOW);
       
       while(valfront >= 16)//wait for player move
        {
         valfront = analogRead(ultrasonic);
         delay(30);
        }
       digitalWrite(pingreenled, LOW);
       digitalWrite(pinredled, HIGH);
       delay(5000);
       //-------------------------------------------------------
       while (sens == 0)//deplasare stanga - move left
          {
            deplasare.write(miscare);
            citiredreapta = digitalRead (senzordreapta);
            while ((citiredreapta == LOW) && (pozitie <= 2))
              {
               citiredreapta = digitalRead (senzordreapta);
               deplasare.write(miscare+2);
              }
           if (citiredreapta == HIGH) 
              {
               Serial.print("pozitie ");
               Serial.println(pozitie);
               deplasare.write(miscare);
               delay(2000);
               
               citire(pozitie); //citire senzori brat
               pozitie = pozitie + 1;
               
               if(pozitie <= 2) deplasare.write(miscare+2);
               delay(500);
              }
              
           if (pozitie > 2)
              {
               checkplayerwin(); //check if player won 
               if(win==0) sens = 1; //if no winning condition is met, game continues
               if(win==1)//player won
                  { 
                    sens = 4;//robot goes to the center of the board
                    pozitie = pozitie - 1;
                  }
              }
          }//end left movement
         //-------------------------------------------------------------------------
          
        while(sens == 1)//move to right
           {
            Serial.println("miscare spre dreapta");
            if(mutare==0) calculmutare();//compute the position where "O" ball will be placed
            
            citirestanga = digitalRead (senzorstanga);
            while((citirestanga == LOW)&&(pozitie >= 1))
              {
               citirestanga = digitalRead (senzorstanga);
               deplasare.write(miscare-2);
               delay(80);
               //Serial.println("citire stanga");
              }
           
           if(citirestanga == HIGH) 
              {
               Serial.println("stop miscare dreapta");
               Serial.print("pozitie ");
               Serial.println(pozitie);
               deplasare.write(miscare);
               delay (500);
               if((pozitie-1)==rowdrop)//check if the robot position is equal with the computed ROW position
                  {
                   //Serial.println("lasa bila");
                   if(pozdrop == 0) pozsus();//check what COLUMN was computed
                   if(pozdrop == 1) pozmij();
                   if(pozdrop == 2) pozjos();
                   pozitie =0;
                  }
               reverse = reverse + 1;
               if(pozitie > 1) deplasare.write(miscare-2);
               //Serial.println("porneste");
               delay (1200);
               pozitie = pozitie - 1;
              }
              
            if(pozitie < 1)
               { 
                 sens = 3;//return to the center of the board
                 Serial.print("pozitie ");
                 Serial.println(pozitie);
                 Serial.print("sens ");
                 Serial.println(sens);
               }
          }//end depl. dreapta
          
        while(sens == 3)//return to center of the board
          {
            deplasare.write(miscare+2);
            delay(500);
            Serial.print("reverse ");
            Serial.println(reverse);
            citirestanga = digitalRead (senzorstanga);
            while((citirestanga == LOW) && (reverse >1))
              {
               citirestanga = digitalRead (senzorstanga);
               deplasare.write(miscare+2);
              }
           if(citirestanga == HIGH) 
              {
               reverse = reverse-1;
              }
              
           if(reverse <= 1)
              {
               sens = 0;
               reverse = 0;
               pozitie = 0;
               delay(1200);
               deplasare.write(miscare);
               checkdocwin();//check if Doc wins
               if(win==2)//doc wins
                 {
                   digitalWrite(pinredled, LOW);
                   for(index =1;index < 70; index++)
                      {
                       pos4 = pos4 + 1;
                       pos1 = pos1 - 1;
                       //dreapta2.write(pos4);//cot dreapta
                       stanga1.write(pos1);//umar stanga
                       delay(30);
                       }
                   delay(2000);
                   for(index =1;index < 70; index++)
                      {
                       pos4 = pos4 - 1;
                       pos1 = pos1 + 1;
                       //dreapta2.write(pos4);
                       stanga1.write(pos1);//umar stanga
                       delay(30);
                      }
                   for(index=1; index <20; index ++)//flash green led
                      {
                       digitalWrite(pingreenled, HIGH);
                       delay(300);
                       digitalWrite(pingreenled, LOW);
                       delay(300);
                      }
                 }
               //delay(10000);
              }
          }//end retur doc
          
      while(sens == 4)//return to center if player wins
          {
            Serial.print("Player wins");
            deplasare.write(miscare-2);
            delay(500);
            citiredreapta = digitalRead (senzordreapta);
            while((citiredreapta == LOW) && (pozitie >=1))
              {
               citiredreapta = digitalRead (senzordreapta);
               deplasare.write(miscare-2);
              }
           if(citiredreapta == HIGH) 
              {
               pozitie = pozitie -1;
              }
              
           if(pozitie <= 0)
              {
               sens = 0;
               reverse = 0;
               pozitie = 0;
               delay(1200);
               deplasare.write(miscare);
               
              for(index =1;index < 70; index++)
                 {
                  pos4 = pos4 + 1;
                  dreapta2.write(pos4);
                  delay(30);
                 }
               delay(2000);
              for(index =1;index < 70; index++)
                 {
                  pos4 = pos4 - 1;
                  dreapta2.write(pos4);
                  delay(30);
                 }
               for(index=1; index <20; index ++)
                  {
                   digitalWrite(pinredled, HIGH);
                   delay(300);
                   digitalWrite(pinredled, LOW);
                   delay(300);
                  }
              }
          }//end retur player
   
     }//end while
}//end loop
